Attribute VB_Name = "ModNet"
Option Explicit
Private Declare Function GetUserName _
Lib "advapi32.dll" Alias "GetUserNameA" _
                  (ByVal lpBuffer As String, _
                  nSize As Long) As Long
                  
Public Declare Function NetServerEnum _
    Lib "Netapi32.dll" ( _
    vServername As Any, _
    ByVal lLevel As Long, _
    vBufptr As Any, _
    lPrefmaxlen As Long, _
    lEntriesRead As Long, _
    lTotalEntries As Long, _
    vServerType As Any, _
    ByVal sDomain As String, _
    vResumeHandle As Any) _
    As Long

Public Declare Sub RtlMoveMemory _
    Lib "Kernel32" ( _
    dest As Any, _
    vSrc As Any, _
    ByVal lSize&)

Public Declare Sub lstrcpyW _
    Lib "Kernel32" ( _
    vDest As Any, _
    ByVal sSrc As Any)
    
Declare Sub lstrcpy _
    Lib "Kernel32" ( _
    vDest As Any, _
    ByVal vSrc As Any)

Declare Sub lstrcpynW _
    Lib "Kernel32" ( _
    ByVal vDest As Any, _
    ByVal vSrc As Any, _
lLength As Long)

Public Declare Function NetApiBufferFree _
    Lib "Netapi32.dll" ( _
    ByVal lpBuffer As Long) _
    As Long

Declare Function NetWkstaGetInfo _
    Lib "Netapi32.dll" ( _
    ByVal sServerName$, _
    ByVal lLevel&, _
    vBuffer As Any) _
    As Long

Declare Function NetMessageBufferSend _
    Lib "Netapi32.dll" ( _
    ByVal sServerName$, _
    ByVal sMsgName$, _
    ByVal sFromName$, _
    ByVal sMessageText$, _
    ByVal lBufferLength&) _
    As Long

Type SERVER_INFO_100
    sv100_platform_id As Long
    sv100_servername As Long
End Type

Public Type SERVER_INFO_101
    dw_platform_id As Long
    ptr_name As Long
    dw_ver_major As Long
    dw_ver_minor As Long
    dw_type As Long
    ptr_comment As Long
End Type

Type WKSTA_INFO_100
    wki100_platform_id As Long
    wki100_computername As Long
    wki100_langroup As Long
    wki100_ver_major As Long
    wki100_ver_minor As Long
End Type


Public Const SV_TYPE_WORKSTATION = &H1
Public Const SV_TYPE_SERVER = &H2
Public Const SV_TYPE_SQLSERVER = &H4
Public Const SV_TYPE_DOMAIN_CTRL = &H8
Public Const SV_TYPE_DOMAIN_BAKCTRL = &H10
Public Const SV_TYPE_TIMESOURCE = &H20
Public Const SV_TYPE_AFP = &H40
Public Const SV_TYPE_NOVELL = &H80
Public Const SV_TYPE_DOMAIN_MEMBER = &H100
Public Const SV_TYPE_LOCAL_LIST_ONLY = &H40000000
Public Const SV_TYPE_PRINT = &H200
Public Const SV_TYPE_DIALIN = &H400
Public Const SV_TYPE_XENIX_SERVER = &H800
Public Const SV_TYPE_MFPN = &H4000
Public Const SV_TYPE_NT = &H1000
Public Const SV_TYPE_WFW = &H2000
Public Const SV_TYPE_SERVER_NT = &H8000
Public Const SV_TYPE_POTENTIAL_BROWSER = &H10000
Public Const SV_TYPE_BACKUP_BROWSER = &H20000
Public Const SV_TYPE_MASTER_BROWSER = &H40000
Public Const SV_TYPE_DOMAIN_MASTER = &H80000
Public Const SV_TYPE_DOMAIN_ENUM = &H80000000
Public Const SV_TYPE_WINDOWS = &H400000
Public Const SV_TYPE_ALL = &HFFFFFFFF

Public SERVERTYPE  As Long

Public Sub TypeOfServer(Combo1 As ComboBox)

  If (Combo1 = "LAN Manager Workstations") Or (Combo1 = "(Nothing Specific)") Then
    SERVERTYPE = SV_TYPE_WORKSTATION
End If

If Combo1 = "LAN Manager Servers" Then
   SERVERTYPE = SV_TYPE_SERVER
End If

If Combo1 = "SQL Servers" Then
    SERVERTYPE = SV_TYPE_SQLSERVER
End If

If Combo1 = "Primary Domain Controllers" Then
    SERVERTYPE = SV_TYPE_DOMAIN_CTRL
End If

If Combo1 = "Backup Domain Controllers" Then
    SERVERTYPE = SV_TYPE_DOMAIN_BAKCTRL
End If

If Combo1 = "Timesource Servers" Then
    SERVERTYPE = SV_TYPE_TIMESOURCE
End If

If Combo1 = "Apple File Protocol Servers" Then
    SERVERTYPE = SV_TYPE_AFP
End If

If Combo1 = "Novell Servers" Then
    SERVERTYPE = SV_TYPE_NOVELL
End If

If Combo1 = "LM 2.x Domain Members" Then
    SERVERTYPE = SV_TYPE_DOMAIN_MEMBER
End If

If Combo1 = "Local Browse List (MB Only)" Then
    SERVERTYPE = SV_TYPE_LOCAL_LIST_ONLY
End If

If Combo1 = "Print Servers" Then
    SERVERTYPE = SV_TYPE_PRINT
End If

If Combo1 = "Dial-in Servers" Then
    SERVERTYPE = SV_TYPE_DIALIN
End If

If Combo1 = "Xenix Servers" Then
   SERVERTYPE = SV_TYPE_XENIX_SERVER
End If

If Combo1 = "MS Novell File & Print Servers" Then
    SERVERTYPE = SV_TYPE_MFPN
End If

If Combo1 = "Windows NT (S&W)" Then
    SERVERTYPE = SV_TYPE_NT
End If

If Combo1 = "WfW Servers" Then
    SERVERTYPE = SV_TYPE_WFW
End If

If Combo1 = "Non-DC NT Servers" Then
    SERVERTYPE = SV_TYPE_SERVER_NT
End If

If Combo1 = "Potential Master Browsers" Then
    SERVERTYPE = SV_TYPE_POTENTIAL_BROWSER
End If

If Combo1 = "Backup Master Browsers" Then
    SERVERTYPE = SV_TYPE_BACKUP_BROWSER
End If

If Combo1 = "Master Browser Servers" Then
    SERVERTYPE = SV_TYPE_MASTER_BROWSER
End If

If Combo1 = "Domain Master Browsers" Then
    SERVERTYPE = SV_TYPE_DOMAIN_MASTER
End If

If Combo1 = "Windows 95 and Later" Then
    SERVERTYPE = SV_TYPE_WINDOWS
End If

If Combo1 = "All Server Types" Then
    SERVERTYPE = SV_TYPE_ALL
End If

End Sub

Public Function FillDomainTree(tvw As TreeView) As Boolean
Dim lReturn As Long
Dim Server_Info As Long
Dim lEntries As Long
Dim lTotal As Long
Dim lMax As Long
Dim vResume As Variant
Dim tServer_info_101 As SERVER_INFO_101
Dim sServer As String
Dim sDomain As String
Dim lServerInfo101StructPtr As Long
Dim X As Long, i As Long
Dim bBuffer(512) As Byte
Dim nodex As Node
Dim lType As Long

        lType = SV_TYPE_DOMAIN_ENUM
        tvw.Nodes.Clear
        Set nodex = tvw.Nodes.Add(, , "R", "Network Domains", "net1")
        nodex.Expanded = True

    lReturn = NetServerEnum(ByVal 0&, 101, Server_Info, lMax, lEntries, lTotal, ByVal lType, sDomain, vResume)

    If lReturn <> 0 Then
        'StatusBar1.Panels("msg").Text = "Systemmessages here"
        
        Exit Function
    End If
        
        
        
    X = 1
    lServerInfo101StructPtr = Server_Info


    Do While X <= lTotal
        DoEvents
        RtlMoveMemory tServer_info_101, ByVal lServerInfo101StructPtr, Len(tServer_info_101)
        lstrcpyW bBuffer(0), tServer_info_101.ptr_name
        i = 0
        Do While bBuffer(i) <> 0
            sServer = sServer & Chr$(bBuffer(i))
            i = i + 2
            DoEvents
        Loop
        
       Set nodex = tvw.Nodes.Add("R", tvwChild, sServer, sServer, "dm")
       nodex.Expanded = True
       Call AddDomainServers(SERVERTYPE, tvw, sServer)
        DoEvents
        X = X + 1
            sServer = ""
        lServerInfo101StructPtr = _
            lServerInfo101StructPtr + _
            Len(tServer_info_101)

    Loop

    lReturn = NetApiBufferFree(Server_Info)
        
End Function

Private Sub AddDomainServers(lType As Long, tvw As TreeView, Parentkey As String)

Dim lReturn As Long
Dim Server_Info As Long
Dim lEntries As Long
Dim lTotal As Long
Dim lMax As Long
Dim vResume As Variant
Dim tServer_info_101 As SERVER_INFO_101
Dim sServer As String
Dim sDomain As String
Dim lServerInfo101StructPtr As Long
Dim X As Long, i As Long
Dim bBuffer(512) As Byte
Dim nodex As Node
Dim icon As String
Dim dwt As Long

        sDomain = StrConv(Parentkey, vbUnicode)

    
    lReturn = NetServerEnum(ByVal 0&, 101, Server_Info, lMax, lEntries, lTotal, ByVal lType, sDomain, vResume)

    If lReturn <> 0 Then
        'StatusBar1.Panels("msg").Text = "Systemmessages here"
        Exit Sub
    End If

    X = 1
    lServerInfo101StructPtr = Server_Info

    Do While X <= lTotal
        DoEvents
        RtlMoveMemory tServer_info_101, ByVal lServerInfo101StructPtr, Len(tServer_info_101)
        lstrcpyW bBuffer(0), tServer_info_101.ptr_name
        i = 0
        Do While bBuffer(i) <> 0
            sServer = sServer & Chr$(bBuffer(i))
            i = i + 2
            DoEvents
        Loop
        
        On Error Resume Next
        dwt = LoWord(tServer_info_101.dw_type)
        If Err.Number <> 0 Then
                Err.Clear
                icon = "cmac"
        Else
                If dwt And SV_TYPE_DOMAIN_CTRL Then
                        icon = "backup"
                ElseIf dwt And SV_TYPE_SQLSERVER Then
                        icon = "sql"
                ElseIf dwt And SV_TYPE_SERVER_NT Then
                        icon = "server"
                Else
                        icon = "cmac"
                End If
        End If
        
        Set nodex = tvw.Nodes.Add(Parentkey, tvwChild, "W" + Parentkey + sServer, sServer, icon)
        nodex.Expanded = True

        DoEvents
        X = X + 1
        sServer = ""
        lServerInfo101StructPtr = lServerInfo101StructPtr + Len(tServer_info_101)

    Loop

    lReturn = NetApiBufferFree(Server_Info)


End Sub
Public Function GetLocalSystemName()
    Dim lReturnCode As Long
    Dim bBuffer(512) As Byte
    Dim i As Integer
    Dim twkstaInfo100 As WKSTA_INFO_100, lwkstaInfo100 As Long
    Dim lwkstaInfo100StructPtr As Long
    Dim sLocalName As String
    
    lReturnCode = NetWkstaGetInfo("", 100, lwkstaInfo100)
 
    lwkstaInfo100StructPtr = lwkstaInfo100
                 
    If lReturnCode = 0 Then
                 
        RtlMoveMemory twkstaInfo100, ByVal _
        lwkstaInfo100StructPtr, Len(twkstaInfo100)
         
        lstrcpyW bBuffer(0), twkstaInfo100.wki100_computername

        i = 0
        Do While bBuffer(i) <> 0
            sLocalName = sLocalName & Chr(bBuffer(i))
            i = i + 2
        Loop
            
        GetLocalSystemName = sLocalName
         
    End If

End Function

Public Function GetDomainName() As String
    
    Dim lReturnCode As Long
    Dim bBuffer(512) As Byte
    Dim i As Integer
    Dim twkstaInfo100 As WKSTA_INFO_100, lwkstaInfo100 As Long
    Dim lwkstaInfo100StructPtr As Long
    Dim sDomainName As String
    
    lReturnCode = NetWkstaGetInfo("", 100, lwkstaInfo100)
 
    lwkstaInfo100StructPtr = lwkstaInfo100
                 
    If lReturnCode = 0 Then
                 
        RtlMoveMemory twkstaInfo100, ByVal lwkstaInfo100StructPtr, Len(twkstaInfo100)
         
        lstrcpyW bBuffer(0), twkstaInfo100.wki100_langroup
        
        
        
        i = 0
        Do While bBuffer(i) <> 0
            sDomainName = sDomainName & Chr(bBuffer(i))
            i = i + 2
        Loop
            
        GetDomainName = sDomainName
         
    End If
        
End Function
Public Function NetSend(msg As String, ToNode As String) As Boolean
Dim lReturnCode As Long
Dim sUnicodeToName As String
Dim sUnicodeFromName As String
Dim sUnicodeMessage As String
Dim lMessageLength As Long
 
    sUnicodeFromName = StrConv(GetLocalSystemName, vbUnicode)
    sUnicodeToName = StrConv(ToNode, vbUnicode)
    sUnicodeMessage = StrConv(msg + vbCrLf & vbCrLf & vbCrLf & "_______________________________________" & vbCrLf & UserName + "(" + GetDomainName + ")", vbUnicode)
    lMessageLength = Len(sUnicodeMessage)

  
    Screen.MousePointer = vbHourglass
    
    

    lReturnCode = NetMessageBufferSend("", _
        sUnicodeToName, _
        sUnicodeFromName, _
        sUnicodeMessage, _
        lMessageLength)
    
   
    If lReturnCode = 0 Then
        Form1.Label1.Caption = "Your message was sent correct.."
    Else
         Form1.Label1.Caption = "Cannot Sent the message. Error No  : " + CStr(lReturnCode)
        
    End If
    
  
   Screen.MousePointer = vbDefault

End Function

  Public Property Get UserName() As Variant
          Dim sBuffer As String
          Dim lSize As Long
          sBuffer = Space$(255)
          lSize = Len(sBuffer)
          Call GetUserName(sBuffer, lSize)
          UserName = Left$(sBuffer, lSize)
          
     End Property
     
Public Function LoWord(DWord As Long) As Integer
    If DWord And &H8000& Then
        LoWord = DWord Or &HFFFF0000
    Else
        LoWord = DWord And &HFFFF&
    End If
End Function
